<template>
    <div
        @click="Click" v-if="shouldDraw" :style="SizeStyle"
        @mouseenter="hover = true" @mouseleave="hover = false" class="worker-dot">
        <div class="label" :style="LabelStyle" v-if="Label !== ''">{{ Label }}</div>
        <q-icon :size="`${dotSize}px`" :name="WorkerIcon" class="animated heartBeat" :style="DotStyle"/>
    </div>
</template>
<style lang='scss' scoped>
.label {
    position: absolute;
    left: 50%;
    padding: 0 5px;
    border-radius: 2px;
    transform: translate(-50%, -75%);
}
</style>


<script lang='ts'>
import {Component, Prop, Vue, Watch} from 'vue-property-decorator';
import {LabelShape, WorkerLabelMode} from "src/classLibrary/Geometry/ShapeDrawer";
import {WorkerPositionResponse} from "src/classLibrary/APIModels/core/workerPositionResponse";
import {differenceInSeconds} from 'date-fns'
import tinycolor from "tinycolor2";

@Component
export default class WorkerIndicator extends Vue {
    @Prop() dotSize!: number;
    @Prop() labelShape!: LabelShape;
    @Prop() inactiveDuration!: number;
    @Prop() borderSize!: number;
    @Prop() borderColor!: string;
    @Prop() labelSize!: number;
    @Prop() labelMode!: WorkerLabelMode;
    @Prop() worker!: WorkerPositionResponse;
    @Prop() selected!: WorkerPositionResponse | null;
    @Prop() hovered!: WorkerPositionResponse | null;
    @Prop() displayInactive!: boolean;
    @Prop() labelColor!: string;
    @Prop() labelBackgroundColor!: string;
    @Prop() labelBackgroundTransparency!: string;
    @Prop() compareTime!: Date;
    @Prop() pulse!: boolean;


    @Prop() width!: number;
    @Prop() height!: number;

    hover: boolean = false;

    @Watch('compareTime')
    OnCompareTimeUpdate() {
        this.Expired();
    }

    @Watch('displayInactive', {immediate: true})
    DisplayInactive() {
        this.Expired();
    }

    @Watch('inactiveDuration', {immediate: true})
    InactiveDuration() {
        this.Expired();
    }

    @Watch('worker', {deep: true, immediate: true})
    OnworkerUpdate() {
        this.Expired();
    }

    Click() {
        this.$emit('select-worker', this.worker);
    }

    get WorkerIcon() {
        switch (this.labelShape) {
            case "circle":
                return "lens";
            case "square":
                return "icofont-square";
            case "triangle":
                return 'icofont-caret-down';
            case "arrow":
                return 'south';
            case "cross":
                return 'clear';
            case "check":
                return 'check'
            case "droplet":
                return 'location_on';

        }
    }

    get LabelStyle() {
        const {r, g, b} = tinycolor(this.labelBackgroundColor).toRgb();
        const background = `rgba(${r},${g},${b},${this.labelBackgroundTransparency})`
        const borderWidth = `${this.borderSize}px`;
        const borderStyle = "solid";
        const borderColor = this.borderColor;
        return {
            borderWidth,
            borderStyle,
            borderColor,
            color: this.labelColor,
            fontSize: this.labelSize + "px",
            background,
        }
    }

    get Label() {
        switch (this.labelMode) {
            case "none":
                return "";
            case "name":
                return this.worker.name;
            case "name-short":
                return this.worker.name.Take(3);
            case "id":
                return this.worker.id;
            case "id-short":
                return this.worker.id.Take(3);
        }
        return "";
    }

    expired = false;

    Expired(): boolean {
        const w = new Date(this.worker.time);
        const now = this.compareTime ?? new Date();
        const diff = differenceInSeconds(w, now).Abs();
        const e = this.inactiveDuration * 60 < diff;
        this.expired = e;
        return e;
    }

    get IsSelected() {
        return this.selected?.id === this.worker.id || this.hovered?.id === this.worker.id;
    }

    get DotStyle() {
        const color = this.worker.color;
        const textShadow = (this.hover || this.IsSelected) ? `0 0 20px ${color}` : 'none'
        if (!this.expired) {
            return {
                animationIterationCount: this.pulse ? "infinite" : "0",
                color,
                textShadow,
                position: 'absolute',
            }
        } else {

            return {
                animationIterationCount: this.pulse ? "infinite" : "0",
                color: 'transparent',
                textStroke: `1px ${color}`,
                textShadow,
                position: 'absolute',
            }
        }
    }

    get shouldDraw() {
        if (this.expired) {
            return !this.displayInactive;
        }
        return true;
    }

    get SizeStyle() {
        const left = (this.worker.x / this.width * 100) + '%';
        const top = (this.worker.y / this.height * 100) + '%';

        return {
            width: this.dotSize + "px",
            height: this.dotSize + "px",
            position: 'absolute',
            top,
            left,
            transform: 'translate(-50%, -50%)',
            transition: 'top 0.2s, left 0.2s'
        }
    }

}
</script>
